// DlgAccel.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"

HWND hDlg          = NULL;
HACCEL hAccelTable = NULL;
HHOOK hHook        = NULL;

LRESULT CALLBACK GetMsgProc(int code, WPARAM wParam, LPARAM lParam)
{
	//    ""  lParam.
	MSG *pMsg = (MSG *)lParam;

	if(pMsg->message >= WM_KEYFIRST && pMsg->message <= WM_KEYLAST)
	{
		//     WM_COMMAND.
		if(TranslateAccelerator(hDlg, hAccelTable, pMsg))
		{
			//   ,  ,    WM_NULL.
			//    ,    ,    "".
			pMsg->message = WM_NULL;
		}
	}

	//   .
	return CallNextHookEx(hHook, code, wParam, lParam);
}

INT_PTR CALLBACK DialogProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_INITDIALOG:
		//    WH_GETMESSAGE   .
		hHook = SetWindowsHookEx(WH_GETMESSAGE, (HOOKPROC)GetMsgProc, NULL, GetCurrentThreadId());

		//   ,       .
		::hDlg = hDlg;
		return TRUE;

	case WM_COMMAND:
		if(LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			//  .
			UnhookWindowsHookEx(hHook);

			//  .
			EndDialog(hDlg, 0);
		}

		if(LOWORD(wParam) == ID_SHOWHIDE)
		{
			//  . / .
			HWND hIcon = GetDlgItem(hDlg, IDC_FACE_ICON);
			ShowWindow(hIcon, IsWindowVisible(hIcon) ? SW_HIDE : SW_SHOW);
		}

		return TRUE;
	}

	return FALSE;
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	//   .
	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDR_ACCELERATOR));

 	//  .
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG), NULL, (DLGPROC)DialogProc);

	//   .
	DestroyAcceleratorTable(hAccelTable);

	return 0;
}